// Application imports
import { AccountDetails } from '@app/_models/account';

/** BlocksBloom object interface */
interface BlocksBloom {
  low: number;
  blockFilter: string;
  blocktxFilter: string;
  alg: string;
  filterRounds: number;
}

/** Conversion object interface */
interface Conversion {
  destinationToken: TxToken;
  fromValue: number;
  sourceToken: TxToken;
  toValue: number;
  trader: string;
  user: AccountDetails;
  tx: Tx;
}

/** Transaction object interface */
interface Transaction {
  from: string;
  sender: AccountDetails;
  to: string;
  recipient: AccountDetails;
  token: TxToken;
  tx: Tx;
  value: number;
  type?: string;
}

/** Transaction data interface */
interface Tx {
  block: number;
  success: boolean;
  timestamp: number;
  txHash: string;
  txIndex: number;
}

/** Transaction token object interface */
interface TxToken {
  address: string;
  name: string;
  symbol: string;
}

/** @exports */
export { BlocksBloom, Conversion, Transaction, Tx, TxToken };
